// Note - this .prg requires the following libraries:
//       Telepathy
//        dGT 


#include "inkey.ch"

FUNCTION main(cParam)
  LOCAL nComPort
  LOCAL cGoodFile
  LOCAL cNextFile
  LOCAL cFileName
  LOCAL nFilesInBuffer
  LOCAL lWasCleared
  LOCAL getlist := {}
  
  CLEAR
  
  IF VALTYPE(cParam) == "C" .AND. (nComPort := VAL(cParam)) > 0 .AND. tp_open(nComPort, , ,9600) == 0
    *** Yeah! ***
  ELSE
    
    DO CASE
      CASE tp_open(1, , ,9600)==0
        nComPort := 1
        
      CASE tp_open(2, , ,9600)==0
        nComPort := 2
        
      OTHERWISE
        @ 10,10 SAY "Sorry could not open com1 or com2..."
        TONE(300,10)
        nComPort := 0
        INKEY(0)
    ENDCASE
  ENDIF
  
  @ 5,10 SAY "Com port:"+STR(nComPort,2)
  
  IF nComPort > 0
    DO WHILE INKEY() # K_ESC
      cGoodFile      := ""                       // Nothing yet...
      nFilesInBuffer := 0
      lWasCleared    := .F.
      
      
      *** Strip all stuff out of the Comm Port Buffer ***
      DO WHILE LEN(cNextFile := TRIM(tp_recv(nComPort, 30, .33))) > 0
        nFilesInBuffer++
        IF .NOT. lWasCleared .AND. nFilesInBuffer > 1 // Screen was not cleared, and More than one...
          lWasCleared := .T.
          Exhibit("/R /Q")                       // Toggles back to character mode
          CLEAR                                  // Clear screen for user feedback
          @10,10 SAY "Waiting for TBrowse to stabilize..."
        ENDIF
        
        cGoodFile := cNextFile
      ENDDO
      
      cFileName := cGoodFile+".PCX"              // last "good" file...
      
      DO CASE
        CASE EMPTY( cFileName )
          *** Do nothing... ***
          
        CASE FILE( cFileName)
          Exhibit( "/R /T:0 /Q " + cFileName )
          
*        OTHERWISE
*          @10,10 SAY "File: [" + cFileName +"] not found."
*          INKEY(1)
      ENDCASE
      
    ENDDO
    Exhibit("/R /Q")                             && Toggles back to character mode
    CLEAR
  ENDIF
  
  tp_close()
  CLEAR
RETURN(NIL)

